local hm_autoaccel = CV_RegisterVar({
	name = "hm_autoaccel",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local STARTTIME = 6 * TICRATE + (3 * TICRATE / 4)

local function autoaccel(p, ...)
	if not hm_autoaccel.value then
		CONS_Printf(p, "This function has been disabled by the host.")
		return
	end
	if not p.HMautoaccel then
		p.HMautoaccel = true
		CONS_Printf(p, "Autoacceleration \130ON\128.")
	else
		p.HMautoaccel = false
		CONS_Printf(p, "Autoacceleration \130OFF\128.")
	end
end
COM_AddCommand("autoaccel", autoaccel)

addHook("PlayerCmd", function(p, cmd)
	if not p.HMautoaccel then return end
	if not hm_autoaccel.value then return end
	if p.spectator then return end
	if (not p.mo) or (not p.mo.valid) then return end
	if p.exiting or (p.pflags & PF_TIMEOVER) then return end
	if p.kartstuff[k_spinouttimer] then return end
	if p.cmd.buttons & BT_BRAKE then
		if p.cmd.buttons & BT_DRIFT or p.kartstuff[k_sneakertimer] or p.kartstuff[k_squishedtimer] then
			cmd.forwardmove = 25<<FRACBITS>>16
			cmd.buttons = $ | BT_ACCELERATE
		else
			if cmd.forwardmove > 0 then
				cmd.forwardmove = 0<<FRACBITS>>16
			end
			cmd.buttons = $ & ~BT_ACCELERATE
		end
	else
		cmd.forwardmove = 50<<FRACBITS>>16
	end
	if leveltime > STARTTIME and not p.kartstuff[k_respawn] then cmd.buttons = $ | BT_ACCELERATE end
end)