local hostmod_timelimit = CV_RegisterVar({
	name = "hm_timelimit",
	defaultvalue = "2",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local hostmod_bail = CV_RegisterVar({
	name = "hm_bail",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local function countActive()
	local pc = 0
	for q in players.iterate
		if not q.spectator then
			pc = $ + 1
		end
	end
	return pc
end

addHook("ThinkFrame", function()
	if not G_BattleGametype() then return end
	if leveltime == 1 then
		for p in players.iterate
			p.HMBTescape = 0
		end
	end
	
	if leveltime == TICRATE then
		COM_BufAddText(server, "timelimit "..hostmod_timelimit.value)
	end
	
	if countActive() > 1 or (not hostmod_bail.value) then return end
	for p in players.iterate
		p.HMBTescape = ($ + 1) or 0
		if p.HMBTescape == 5*TICRATE then
			chatprintf(p, "\x83*Type \130bail\x83 to return to the voting screen.")
		end
	end
end)

addHook("PlayerMsg", function(source, msgtype, target, msg)
	if not G_BattleGametype() or msgtype != 0 or (not hostmod_bail.value) then
		return
	end
	if not (msg:lower() == "bail") then return end
	if countActive() > 1 then
		chatprintf(source, "\133*You can only bail when no one is playing. Be patient!", true)
		return true
	end
	if not source.spectator then
		COM_BufAddText(server, "exitlevel")
	end
end)