local function choose(p, ...)
	if not ... then
		CONS_Printf(p, "Usage: choose <option1> [option2] [option3] ...")
	end
	local args = {...}
	local index = P_RandomRange(1, #args)
	COM_BufInsertText(p, args[index]:gsub("'", '"'))
end
COM_AddCommand("hm_choose", choose)

local function chooseweighted(p, ...)
	if not ... then
		CONS_Printf(p, "Usage: chooseweighted <option1> <weight1> [option2] [weight2] [option3] [weight3] ...")
	end
	local args = {...}
	local commands = {}
	local weights = {}
	local totalweight = 0
	local index = 0
	while index < #args
		index = $ + 1
		local fug = args[index]:gsub("'", '"')
		table.insert(commands, fug)
		index = $ + 1
		hm_dprint(args[index])
		table.insert(weights, args[index])
		totalweight = $ + args[index]
	end
	local target = P_RandomRange(1, totalweight)
	for k, v in ipairs(commands)
		if target <= tonumber(weights[k]) then
			COM_BufInsertText(p, commands[k])
			return
		end
		target = $ - weights[k]
	end
end
COM_AddCommand("hm_chooseweighted", chooseweighted)