COM_AddCommand("playsound", function(p, s)
	if not s then
		CONS_Printf(p, "Usage: playsound <string/number>")
		return
	end

	local sound = tonumber(s)
	if sound ~= nil then
		if sound < 1 or sound >= #sfxinfo then
			CONS_Printf(p, "Sound ID "..sound.." out of range")
			return
		end
	else
		sound = _G["sfx_"..s]
		if not sound then
			CONS_Printf(p, "Sound "..s.." not found")
			return
		end
	end
	S_StartSound(nil, sound)
end, COM_ADMIN)

COM_AddCommand("playmusic", function(p, m, c)
	if m then
		S_ChangeMusic(m)
		if c then
			S_ShowMusicCredit()
		end
	else
		CONS_Printf(p, "Usage: playmusic <string> <credit>")
	end
end, COM_ADMIN)

local musictypes = {
	[0] = "NONE",
	"CMD",
	"WAV",
	"MOD",
	"MIDI",
	"OGG",
	"MP3",
	"MP3_MAD_UNUSED",
	"FLAC",
	"MODPLUG_UNUSED",
	"GME",
	"MPT", -- Saturn only
}

COM_AddCommand("showmusic", function()
	local name = S_MusicName()
	local type = S_MusicType()
	if name ~= "" then
		print(name.." (type: "..(musictypes[type] or "Unknown")..")")
		S_ShowMusicCredit()
	else
		print("No music is playing.")
	end
end, COM_LOCAL)
