local hostmod_scheduler = CV_RegisterVar({
	name = "hm_schedule",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local function schedule(p, seconds, ...)
	if p != server then
		CONS_Printf(p, "Please run this from your server's console...it's too dangerous to let remote players have this!")
		return
	end
	if not tonumber(seconds) then
		CONS_Printf(p, 'Usage: schedule <timer in seconds> "<command to run>"')
		return
	end
	seconds = tonumber($)
	if seconds < 1 then
		CONS_Printf(p, "Timer > 0, please.")
		return
	end
	if not ... then
		CONS_Printf(p, "Supply at least one command, please.")
		return
	end
	if not server.HMscheduled then server.HMscheduled = {} end
	table.insert(server.HMscheduled, {basetime = seconds, timer = seconds, command = {...}})
	print("OK! Running \130"..table.concat({...}, " / " ).."\128 every \130"..seconds.." seconds.")
end
COM_AddCommand("hm_schedule_add", schedule, 1)

local function listtasks(p, ...)
	for _,t in pairs(server.HMscheduled)
		print("In \130"..t.timer.." seconds: \130"..table.concat(t.command, " / "))
	end
end
COM_AddCommand("hm_schedule_list", listtasks, 1)

local function tickScheduler()
	if not hostmod_scheduler.value then return end
	if not server.HMticktimer then server.HMticktimer = 0 end
	if not server.HMscheduled then server.HMscheduled = {} end
	for p in players.iterate -- ACHTUNG HACK WARNING
		HM_Random() -- burn random numbers in a vaguely unpredictable way
	end
	server.HMticktimer = ($ + 1) % 35
	if server.HMticktimer then return end
	-- following runs once every second
	for _,t in pairs(server.HMscheduled)
		t.timer = $ - 1
		if t.timer == 0 then
			local i = HM_RandomRange(1, #t.command)
			CONS_Printf(server, t.basetime.." seconds elapsed, running \130"..t.command[i].." \128as server.")
			t.timer = t.basetime
			COM_BufAddText(server, t.command[i])
		end
	end
end

addHook("IntermissionThinker", tickScheduler)
addHook("ThinkFrame", tickScheduler)
addHook("VoteThinker", tickScheduler)