local miniperfstats = CV_RegisterVar({
	name = "ministats",
	defaultvalue = "Off",
	flags = 0,
	possiblevalue = CV_OnOff
})

local framecount = 0
local lastframecount = 0
local framecounts = {}
local TICRATE = TICRATE
local framecap = 35

addHook("ThinkFrame", function()
	if leveltime == 1 then
		framecap = CV_FindVar("frameratecap") and CV_FindVar("frameratecap").value or 35
	end
	if leveltime == 0 or framecounts[TICRATE] == nil then
		for i = 1, TICRATE
			framecounts[i] = 0
		end
	end
	if not miniperfstats.value then return end
	framecounts[leveltime%TICRATE+1] = framecount
	framecount = 0
	lastframecount = 0
	for i=1, TICRATE
		lastframecount = $ + framecounts[i]
	end
end)

local flags = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_50TRANS|V_ALLOWLOWERCASE
local warnflags = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_40TRANS|V_ALLOWLOWERCASE|V_YELLOWMAP

hud.add(function(v, p, c)
	if not miniperfstats.value then return end
	if (splitscreen or replayplayback) then return end
	if not (consoleplayer and consoleplayer.valid) then return end
	framecount = $ + 1
	local yoff = 10
	local ping = consoleplayer.ping
	local xoff = 307
	if true then
		if lastframecount < framecap - 1 then
			v.drawString(xoff-12, 190, lastframecount.."fps", warnflags, "thin-right")
		else
			v.drawString(xoff-12, 190, lastframecount.."fps", flags, "thin-right")
		end
		
		local ping_gfxnum, ping_values = 1, {2, 4, 7, 10}
		for i = 1, #ping_values
			if (consoleplayer.ping >= ping_values[i]) then ping_gfxnum = i+1 end
		end
		v.draw(xoff-1, 190, v.cachePatch("HMPING"..ping_gfxnum), flags)
		v.drawString(xoff + 1, 190, "D"..min(consoleplayer.cmd.latency, 9), flags, "thin")
		--v.drawString(318, 190 - 5, "D"..consoleplayer.cmd.latency, flags, "small-right")
		--v.drawString(318-8, 190 + 4, consoleplayer.cmd.latency, flags, "small")
	else
		if consoleplayer.cmd.latency == 0 then
			yoff = 0
		else
			if ping > 999 then ping = ":D?" end
			local netstring = ping.."ms/D"..consoleplayer.cmd.latency
			v.drawString(308, 190, netstring, flags, "thin-right")
			
			local ping_gfxnum, ping_values = 1, {2, 4, 7, 10}
			for i = 1, #ping_values
				if (consoleplayer.ping >= ping_values[i]) then ping_gfxnum = i+1 end
			end
			v.draw(318, 190, v.cachePatch("HMPING"..ping_gfxnum), flags)
		end
		
		v.drawString(318, 190 - yoff, lastframecount.." FPS", flags, "thin-right")
	end
end)